//anti sneaker smuggling lua because god I hate people hanging on to sneakers for hours
//freeman#7626 reuse and mangle as required

local antismuggla = CV_RegisterVar({
	name = "wa_antismuggla",
	defaultvalue = "On",
	flags = CV_NETVAR,
	possiblevalue = CV_OnOff
})//controls on/off

local antismuggla_time = CV_RegisterVar({
	name = "wa_antismuggla_time",
	defaultvalue = 350,
	flags = CV_NETVAR,
	possiblevalue = CV_Natural
})//how long (tics) you have to be in first before antismuggla drops your shit - 35 = 1 second

local antismuggla_dist = CV_RegisterVar({
	name = "wa_antismuggla_dist",
	defaultvalue = 2000,
	flags = CV_NETVAR,
	possiblevalue = CV_Natural
})//A configurable distance before antismuggla starts rapid draining duration items

local antismuggla_drainrate = CV_RegisterVar({
	name = "wa_antismuggla_drainrate",
	defaultvalue = 3,
	flags = CV_NETVAR,
	possiblevalue = CV_Natural
})//A configurable distance before antismuggla starts rapid draining duration items

local antismuggla_rocket_dist = CV_RegisterVar({
	name = "wa_antismuggla_rocket_dist",
	defaultvalue = 400,
	flags = CV_NETVAR,
	possiblevalue = CV_Natural
})//A configurable distance before antismuggla starts rapid draining rocket sneakers

local antismuggla_rocket_drainrate = CV_RegisterVar({
	name = "wa_antismuggla_rocket_drainrate",
	defaultvalue = 10,
	flags = CV_NETVAR,
	possiblevalue = CV_Natural
})//A configurable distance before antismuggla starts rapid draining rocket sneakers


local playercount = 0
local nextPlayercountCheck = -1
addHook("ThinkFrame", function()
	if not antismuggla.value then return end
	--Disable this for various modes
	if CV_FindVar("combi_active") and CV_FindVar("combi_active").value == 1 then return end
	if CV_FindVar("frontrun_enabled") and CV_FindVar("frontrun_enabled").value == 1 then return end
	if CV_FindVar("driftnitro") and CV_FindVar("driftnitro").value == 1 then return end
	
	if leveltime > 1 and leveltime < 4 then
		nextPlayercountCheck = leveltime --Overwrite this for the first few ticks to make sure it sets
	end
	
	--Get player count before running anything below
	if playercount == 0 or nextPlayercountCheck < leveltime then --Cache this result in order to reduce the amount of looping this is doing in the background
		playercount = 0 --Reset
		for p in players.iterate
			if playercount > 1 then break end --Exit early, this is the only relevant data
			if p.valid then
				if not p.mo or not p.mo.valid then continue end
				playercount = $+1
			end		
		end
		nextPlayercountCheck = leveltime + 350 -- 10 second intervals
	end
	--Only run this if multiple people are playing
	if playercount > 1 then
		for p in players.iterate
			if not p.valid then continue end
			if not p.mo or not p.mo.valid then continue end
			if p.kartstuff[k_position] > 1 then continue end --This script doesn't care about anyone not in first so get out of it ASAP
			if p.antismugglatimer == nil then p.antismugglatimer = 0 end
			
			//rapidly drain duration items if defined distance fracs ahead of second place
			if (p.kartstuff[k_rocketsneakertimer] or p.kartstuff[k_invincibilitytimer] or p.kartstuff[k_growshrinktimer] or p.kartstuff[k_hyudorotimer]) then
				local secondplace = nil
				for q in players.iterate
					if secondplace ~= nil then break end --Exit early, found answer
					if q and q.valid and not q.spectator and q.kartstuff[k_position] == 2 then
						secondplace = q
					end
				end
				if secondplace ~= nil then
					local dist = abs(P_AproxDistance(P_AproxDistance(p.mo.x - secondplace.mo.x, p.mo.y - secondplace.mo.y),p.mo.z - secondplace.mo.z)/FRACUNIT)
					if dist > antismuggla_dist.value then
						//Checking all of these at once in case of item stacking
						if p.kartstuff[k_invincibilitytimer] then
							p.kartstuff[k_invincibilitytimer] = max(1,$-antismuggla_drainrate.value)
						end
						if p.kartstuff[k_growshrinktimer] then
							p.kartstuff[k_growshrinktimer] = max(1,$-antismuggla_drainrate.value)
						end
						if p.kartstuff[k_hyudorotimer] then
							p.kartstuff[k_hyudorotimer] = max(1,$-antismuggla_drainrate.value)
						end
					end
					if p.kartstuff[k_rocketsneakertimer] and dist > antismuggla_rocket_dist.value then
						//Changing slipstream to universal stacks makes this a bit strong
						p.kartstuff[k_rocketsneakertimer] = max(1,$-antismuggla_rocket_drainrate.value)			
					end
				end
			end
			
			//drop sneakers, grow, or invuln if held in first for longer than configured
			if (p.kartstuff[k_itemtype] == KITEM_SNEAKER or p.kartstuff[k_itemtype] == KITEM_INVINCIBILITY or p.kartstuff[k_itemtype] == KITEM_GROW) then
				if p.antismugglatimer >= antismuggla_time.value then
					K_DropItems(p)
					S_StartSound(nil, 120, p) //sfx_shldls
				else //otherwise, we were not prepared to drop anyways
					p.antismugglatimer = $+1
					if p.antismugglatimer == 1 then //first frame in first with an item
						S_StartSound(nil, 24, p) //sfx_buzz1
					elseif p.antismugglatimer%35 == 0 then
						S_StartSound(nil, 98, p) //sfx_ding
					end
				end
			elseif p.antismugglatimer > 0 then
				p.antismugglatimer = $-1
			end
		end
	end
end)

local smugx,smugy = 22,17

-- Funny HUD + Helpers
local function countActiveSplitScreenPlayers()
	local number = 0

	for p in displayplayers.iterate do
		if p.valid then number = $ + 1 end
	end

	return number
end

local function whichSplitscreenPlayerIsThis(thisPlayer)
	local number = 1
	local howManyPlayers = countActiveSplitScreenPlayers()

	if howManyPlayers == number then return number
	elseif howManyPlayers > 1 then
		for p in displayplayers.iterate do
			if p == thisPlayer then break
			else number = $ + 1
			end
		end
	end 

	return number
end

--Kind of redundant for this purpose but whatever
local function isPlayerItemBoxOccupied(player)

	if 	player.kartstuff[k_itemroulette] 	> 0 or 	-- under any roulette
		player.kartstuff[k_eggmanexplode]	> 0 or	-- getting eggman'd
		player.kartstuff[k_itemtype]       ~= 0	or	-- has item (-1 is sad face)
		player.kartstuff[k_curshield]		> 0 or	-- using thunder shield
		player.kartstuff[k_stealingtimer] 	> 0 or 	-- stealing something
		player.kartstuff[k_stolentimer]		> 0 or 	-- getting stolen from
		player.kartstuff[k_growshrinktimer] > 0 or  -- beeg
		player.kartstuff[k_rocketsneakertimer] > 0 or -- rocket sneakers
		player.kartstuff[k_itemheld] == true		-- dragging/deployed item
		
		return true
	end

	return false
end

hud.add(function(v, p, c) //I HATE HUD CODE I HATE HUD CODE
	if splitscreen then return end //lmao
	if p and p.valid and p.mo and p.mo.valid and not p.spectator then//paranoia
		if (p.antismugglatimer and p.antismugglatimer > 0) and 
			(p.kartstuff[k_itemtype] == KITEM_SNEAKER or p.kartstuff[k_itemtype] == KITEM_INVINCIBILITY or p.kartstuff[k_itemtype] == KITEM_GROW)
			and p.kartstuff[k_position] <= 1 then
				local struggletimer = max(antismuggla_time.value - p.antismugglatimer, 0)
			if struggletimer <= 4*TICRATE then
				local smugflags = V_SNAPTOTOP|V_SNAPTOLEFT
				if leveltime%8 >= 4 then
					smugflags = $|V_30TRANS
				end
				if struggletimer > 2*TICRATE and struggletimer < 3*TICRATE then
					v.draw(smugx,smugy,v.cachePatch("K_EGGN2"),smugflags)
				elseif struggletimer > TICRATE and struggletimer < 2*TICRATE then
					v.draw(smugx,smugy,v.cachePatch("K_EGGN1"),smugflags)
				elseif struggletimer > 0 and struggletimer < TICRATE then
					v.draw(smugx,smugy,v.cachePatch("K_EGGN0"),smugflags)
				end
			end
		end
		
		//TODO - Draw timer bar for how long Grow+Invuln has remaining
		if p.kartstuff[k_invincibilitytimer] or p.kartstuff[k_growshrinktimer] or p.kartstuff[k_hyudorotimer] then
			local splitscreenNum = countActiveSplitScreenPlayers()

			local barX		= 10
			local barY 		= 11
			local barWidth 	= 40
			
			-- we move barY down if player has item/roulette/held/growth timer
			if isPlayerItemBoxOccupied(p) then
				barY = $ + 43
			end
			
			local flags		= V_SNAPTOTOP|V_HUDTRANS;
			local thisPlayer = whichSplitscreenPlayerIsThis(p)
			if splitscreenNum > 1 then -- more than one
				if splitscreenNum == 2 then 	-- 2 players
					flags = $|V_SNAPTOLEFT 

					if thisPlayer == 2 then
						barY = $ + 106 			-- half the regular height + 8 offset pixels.
					end

				elseif splitscreenNum > 2 then	-- more than 2
					-- base pos values as ref. to the the smol item boxes
					barX 		= $ / 2
					barY 		= $ / 2
					barWidth 	= $ / 2 -- make it smol like the item box

					-- the hud snaps to the right on players 2 and 4
					-- left otherwise
					if thisPlayer % 2 == 0 then
						flags = $|V_SNAPTORIGHT
						barX  = 320 - barWidth - $
					else
						flags = $|V_SNAPTOLEFT
					end

					-- players 3 and 4 (lower ones) have their regular weird offset.
					if thisPlayer >= 3 then barY = $ + 108 end
				end
			else flags = $|V_SNAPTOLEFT
			end
			
			local timer = 0
			local maxDuration = 0
			if p.kartstuff[k_invincibilitytimer] then
				timer = p.kartstuff[k_invincibilitytimer] -- 10 seconds - 10*TICRATE
				maxDuration = 10*TICRATE
			elseif p.kartstuff[k_growshrinktimer] then
				timer = p.kartstuff[k_growshrinktimer] -- 12 seconds - 12*TICRATE
				maxDuration = 12*TICRATE
			elseif  p.kartstuff[k_hyudorotimer] then
				timer = p.kartstuff[k_hyudorotimer]  -- 7 seconds base, 14 seconds kartmp - 7*TICRATE/14*TICRATE
				maxDuration = 14*TICRATE
			end
			
			if timer > 0 then
				local funnyCalc1 = FixedMul(FixedDiv(FixedDiv((barWidth * 100) * FRACUNIT, maxDuration * FRACUNIT), 100 * FRACUNIT), timer * FRACUNIT)
				
				local visualTimer = FixedInt(funnyCalc1)

				--This makes it go UP, not down
				--local barActualWidth = barWidth - visualTimer
				
				-- bg
				v.drawFill(barX, 	barY-1, barWidth, 		1, 21|flags)
				v.drawFill(barX-1, 	barY, 	barWidth + 2, 	1, 23|flags)
				v.drawFill(barX-1, 	barY+1, barWidth + 2, 	1, 24|flags) 
				v.drawFill(barX-1, 	barY+2, barWidth + 2, 	1, 25|flags)
				v.drawFill(barX, 	barY+3, barWidth, 		1, 26|flags)
				-- these parts move
				--v.drawFill(barX+1, 	barY, 	barActualWidth - 2, 1, 7|flags)
				--v.drawFill(barX, 	barY+1, barActualWidth, 	1, 9|flags)
				--v.drawFill(barX+1, 	barY+2, barActualWidth - 2, 1, 12|flags)
				v.drawFill(barX+1, 	barY, 	visualTimer - 2, 1, 7|flags)
				v.drawFill(barX, 	barY+1, visualTimer, 	1, 9|flags)
				v.drawFill(barX+1, 	barY+2, visualTimer - 2, 1, 12|flags)
			end
		end
	end
end)

local function netvars(net)
	playercount = net($)
	nextPlayercountCheck = net($)
end
addHook("NetVars", netvars)