//spinout lua by freeman#2651
//reduces wipeout timer constantly if its not on its own
//to prevent infinite wipeout dumb shit that I hate
//work in progress

//I am the one who works - Onyo
local spinoutlua = CV_RegisterVar({
	name = "wa_spinoutlua",
	defaultvalue = "On",
	flags = CV_NETVAR,
	possiblevalue = CV_OnOff
})//controls on/off

local tickratemin =  CV_RegisterVar({
	name = "wa_tickratemin",
	defaultvalue = 1,
	flags = CV_NETVAR,
	possiblevalue =  {MIN = 1, MAX = 50}
})

-- Don't set this lower than tickratemin, obviously
local tickratemax =  CV_RegisterVar({
	name = "wa_tickratemax",
	defaultvalue = 5,
	flags = CV_NETVAR,
	possiblevalue =  {MIN = 2, MAX = 50}
}) 

local function recalcTickRate(p)
	--y = lo ticrate + (stat total (variable) - stat min) * ((hi ticrate - lo ticrate) / (statmax - statmin))
	--Default hi ticrate 6, lo ticrate 2, statmax 18, statmin 2
	--I don't care if this could be condensed, adding the FRACUNIT layer made me tear my hair out
	local statTotal = (p.kartweight - 1)
	local divisionstep = FixedDiv( tickratemax.value - tickratemin.value , 9 - 1 )
	local multiplystep = FixedMul( statTotal*FRACUNIT, divisionstep )
	local thetrunc = FixedTrunc( multiplystep )
	
	p.wa_stickrate = FixedInt( thetrunc ) + tickratemin.value
	p.wa_sremainder = FixedInt( (multiplystep - thetrunc) * 100 )
	p.wa_weightcache = p.kartweight --This is most likely cheaper than a list because I know how bad this language is with lists.
	p.wa_stimeremainder = 0
	p.wa_sticktofire = 0
	--DEBUG
	--print(p.name .. " recalced. Tickrate ".. tostring(p.wa_stickrate) .. " remainder " .. tostring(p.wa_sremainder))
end

addHook("ThinkFrame", function()
	if not spinoutlua.value then return end
	
	for p in players.iterate
		if p and p.valid and p.mo and not p.spectator then
			if p.lastspinouttimer == nil then p.lastspinouttimer = 0 end
			--Determine if cached values need a recalc
			if not p.wa_stickrate or ( not p.wa_weightcache or p.wa_weightcache != p.kartweight ) then
				recalcTickRate(p)
			end
			
			if not p.kartstuff[k_spinouttimer] and p.wa_sticktofire == 0 then
				p.lastspinouttimer = p.kartstuff[k_spinouttimer]
				continue --Shoo shoo, get out of here. 	
			end 
			
			if p.kartstuff[k_spinouttimer] and p.kartstuff[k_spinouttimer] == p.lastspinouttimer and p.wa_sticktofire == 0 then
				--Initalize p.wa_sticktofire
				p.wa_sticktofire = leveltime + p.wa_stickrate
				p.wa_stimeremainder = 0
				--DEBUG
				--print("Initialize Time "..tostring(p.wa_sticktofire).. " Remainder " .. tostring(p.wa_stimeremainder) )
			elseif p.kartstuff[k_spinouttimer] and p.kartstuff[k_spinouttimer] == p.lastspinouttimer and leveltime >= p.wa_sticktofire then
				p.kartstuff[k_spinouttimer] = max($-1,0)	
				
				p.wa_stimeremainder = $ + p.wa_sremainder --Increment remainder counter				
							
				local tickdelay = FixedInt( FixedTrunc( FixedDiv( p.wa_stimeremainder , 100 ) ) )--If remainder is > 100, then calculate how much to delay the next tick		
				p.wa_stimeremainder = p.wa_stimeremainder % 100 --Clear counter of the 100's place since it was factored in		
				
				--Set the next tick to fire on
				p.wa_sticktofire = leveltime + p.wa_stickrate + tickdelay
				
				--DEBUG
				--print(tostring(leveltime) .. " - Ticked down by 1 ("..tostring(p.wa_stickrate).."."..tostring(p.wa_sremainder)..") Current Remainder ".. tostring(p.wa_stimeremainder) .. " Next Tic " .. tostring(p.wa_sticktofire) )
			elseif not p.kartstuff[k_spinouttimer] and p.wa_sticktofire != 0 then
				--Clean up
				p.wa_sticktofire = 0
				p.wa_stimeremainder = 0
				
				--DEBUG
				--print("Spinout timers reset")
			end
			
			//print(p.name.."; spinout: "..p.kartstuff[k_spinouttimer]..", wipeout: "..p.kartstuff[k_wipeoutslow])
			p.lastspinouttimer = p.kartstuff[k_spinouttimer]
		end
	end
end)